Attribute VB_Name = "modBNET"
Public Enum BNCS_STATES
    BNS_UNACTIVE = 0
    BNS_CONNECTING = 1
    BNS_GET_VB = 2
    BNS_0x50 = 3
    BNS_GET_CR = 4
    BNS_0x51 = 5
    BNS_ACC_LOGON = 6
    BNS_ACC_CREATE = 7
    BNS_ENTER_CHAT = 8 'waiting for 0x0A
    BNS_CHAT = 9
    BNS_GAME = 10
End Enum

Public hBnHandle            As Long
Public hBnUHandle           As Long
Public hBnData              As String
Public hBnState             As BNCS_STATES
Public hBnServer            As String
Public hBnClient            As Long
Public hBnVersionB          As Long
Public hBnClientToken       As Long
Public hBnServerToken       As Long
Public hBnUDPToken          As Long
Public hBnCDKey             As String
Public hBnAccount           As String
Public hBnPassword          As String
Public hBnUDPStamp          As Long
Public hBnHomeChannel       As String
Public hBnBNLS              As String
'//Logon variables
Public hBnChannel           As String
Public hBnAccountB          As String 'unique account
Public hBnAccountStats      As String
'//Game variables (0x1C)
Public hBnGameState         As Long
Private hBnGameTime         As Double
Private hBnGameType         As Integer
Private hBnGamePenalty      As Integer
Private hBnGameStatsCode    As Long
Private hBnGameName         As String
Private hBnGamePass         As String
Private hBnGameStats        As String

Public Sub ConnectBNET()
    If (modConfig.TestConfig() = False) Then Exit Sub
    hBnServer = modConfig.hBnetAddr
    hBnClient = modConfig.hClient
    hBnCDKey = modConfig.hCDKey
    hBnAccount = modConfig.hAccount
    hBnPassword = modConfig.hPassword
    hBnHomeChannel = modConfig.hChannel
    hBnBNLS = modConfig.hBnlsAddr
    Call modCHAN.ClearBnetUsers
    hBnData = vbNullString
    hBnState = BNS_CONNECTING
    sBNET vbYellow, "Connecting.."
    '//Clear the bnet channel list
    Form1.hSckBNET.Close
    Form1.hSckBNET.Connect hBnServer, 6112&
End Sub
Public Sub DisconnectBNET()
    hBnState = BNS_UNACTIVE
    If (Not Form1.hSckBNET.State = sckClosed) Then sBNET vbRed, "Disconnected."
    Form1.hSckBNET.Close
    Form1.hSckBNLS.Close
    If (Not hBnState = BNS_GAME) Then
        Form1.hSckUDP.Close
    End If
    Call modCHAN.ClearBnetUsers
End Sub

Public Sub OnBNETConnect()
    If (Not hBnState = BNS_CONNECTING) Then Exit Sub
    hBnState = BNS_GET_VB
    hBnHandle = Form1.hSckBNET.SocketHandle
    hBnClientToken = GetTickCount()
    hBnUDPStamp = 0
    hBnUHandle = 0
    Call iClear
    Call iBYTE(&H1)
    Call iPacket(hBnHandle)
    Call modBNLS.ConnectBNLS
    Exit Sub
OnBNETConnectErr:
End Sub
Public Sub OnBNETData(ByRef S As String)
    On Error GoTo OnBNETDataErr
    Dim lngLengh        As Long
    hBnData = hBnData & S
    While (Len(hBnData) > 3)
        If (Not Asc(hBnData) = &HFF) Then GoTo OnBNETDataErr
        Call CopyMemory(lngLengh, ByVal Mid$(hBnData, 3, 2), 2)
        If (lngLengh > 5000) Then GoTo OnBNETDataErr
        If (lngLengh > Len(hBnData)) Then Exit Sub
        S = Left$(hBnData, lngLengh)
        hBnData = Mid$(hBnData, (1 + lngLengh))
        Call Parse(S)
    Wend
    Exit Sub
OnBNETDataErr:
    hBnData = vbNullString
End Sub
Public Sub OnBNETError(Optional ByVal lngErrNumber As Long = -1, Optional ByVal strDescription As String = vbNullString)
    hBnState = BNS_UNACTIVE
    Form1.hSckBNET.Close
    Form1.hSckBNLS.Close
    If (Not hBnState = BNS_GAME) Then
        Form1.hSckUDP.Close
    End If
    If (lngErrNumber = 0) Then
        sBNET vbRed, "Connection Closed."
    Else
        sBNET vbRed, "Error" & IIf((lngErrNumber = -1), ":", "(" & lngErrNumber & ")") & Space$(1) & strDescription
    End If
    Call modCHAN.ClearBnetUsers
End Sub


Public Sub OnBNETVByte(ByVal lngVByte As Long)
    If (Not hBnState = BNS_GET_VB) Then Exit Sub
    hBnState = BNS_0x50
    hBnVersionB = lngVByte
    Call SB50(lngVByte)
    Call modCtrl.sckBind(Form1.hSckUDP, 6113, 10000)
    hBnUHandle = Form1.hSckUDP.SocketHandle
End Sub
Public Sub OnBNETCR(ByVal lngVersion As Long, ByVal lngChecksum As Long, ByVal strExeInfo As String)
    If (Not hBnState = BNS_GET_CR) Then Exit Sub
    hBnState = BNS_0x51
    Dim lngProduct      As Long
    Dim lngPublic       As Long
    Dim lngPrivate      As Long
    If (modCDKEY.KeyDecode(hBnCDKey, lngProduct, lngPublic, lngPrivate) = False) Then
        Call OnBNETError(, "CDkey Decode Failed.")
        Exit Sub
    End If
    Call SB51(lngProduct, lngPublic, lngPrivate, Len(hBnCDKey), lngVersion, lngChecksum, strExeInfo)
End Sub


Public Sub OnBNETDataU(ByRef S As String, ByRef lngID As Long, ByRef lngAddr As Long, ByRef intPort As Integer)
    On Error GoTo OnBNETDataUErr
    Dim lngA            As Long
    If (lngID = &H3&) Then
        If (Len(S) < 8) Then Exit Sub
        Call CopyMemory(lngID, ByVal Mid$(S, 5, 4), 4)
        If (lngID = &H0&) Then
            If (Not hBnState = BNS_GAME) Then Exit Sub
            Call SU03(&H1, lngAddr, intPort)
        ElseIf (lngID = &H1&) Then 'answer
            If (Not hBnState = BNS_CHAT) Then Exit Sub
            If (Not modGUI.hGUIA = GUI_JOIN) Then Exit Sub
            Call modGUI.hGUI.OnPingAnswer(lngAddr, intPort)
        End If
    ElseIf (lngID = &H5&) Then 'UDP Stamp
        If (Len(S) < 8) Then Exit Sub
        If (hBnState < BNS_0x50) Or (hBnState >= BNS_ENTER_CHAT) Then Exit Sub
        Call CopyMemory(lngA, ByVal Mid$(S, 5, 4), 4)
        If (Not hBnUDPStamp = lngA) Then
            hBnUDPStamp = lngA
            sBNET vbBlue, "UDP Stamp: " & Mid$(S, 5, 4)
        End If
    End If
OnBNETDataUErr:
End Sub
Private Sub Parse(ByRef S As String)
    Dim bID     As Byte
    bID = Asc(Mid$(S, 2, 1))
    Select Case bID
        Case &H9:   Call HB09(S)
        Case &HA:   Call HB0A(S)
        Case &HB
        Case &HF:   Call HB0F(S)
        Case &H1C:  Call HB1C(S)
        Case &H25:  Call SB25(S)
        Case &H3A:  Call HB3A(S)
        Case &H3D:  Call HB3D(S)
        Case &H4A:  Call HB4A(S)
        Case &H4C:  Call HB4C(S)
        Case &H50:  Call HB50(S)
        Case &H51:  Call HB51(S)
        Case &H5E:  Call modWARDEN.WardenOnData(S)
    End Select
End Sub
Private Sub HB09(ByRef S As String)
    If (Len(S) < 12) Then Exit Sub
    If (Not hBnState = BNS_CHAT) Then Exit Sub
    If (Not modGUI.hGUIA = GUI_JOIN) Then Exit Sub
    On Error GoTo HB09Err
    Call modGUI.hGUI.OnGameList(S)
HB09Err:
End Sub
Private Sub HB0A(ByRef S As String)
    Dim lngPos          As Long
    If (Len(S) < 7) Then Exit Sub
    If (hBnState = BNS_ENTER_CHAT) Then hBnState = BNS_CHAT
    lngPos = 5
    hBnAccount = GetSTRING(Mid$(S, lngPos)): lngPos = lngPos + Len(hBnAccount) + 1
    If (lngPos > (Len(S))) Then Exit Sub
    hBnAccountStats = GetSTRING(Mid$(S, lngPos)): lngPos = lngPos + Len(hBnAccountStats) + 1
    If (lngPos > (Len(S))) Then Exit Sub
    hBnAccountB = GetSTRING(Mid$(S, lngPos))
    On Error GoTo HB0AErr
    If (modGUI.hGUIA = GUI_CHAT) Then
        Call modGUI.hGUI.OnEnterChat
    End If
HB0AErr:
End Sub
Private Sub HB0F(ByRef S As String)
    If (Len(S) < 31) Then Exit Sub
    'If (hBnState < BNS_ENTER_CHAT) Then Exit Sub
    Dim lngEvent        As Long
    Dim lngFlags        As Long
    Dim lngPing         As Long
    Dim strUser         As String
    Dim strMsg          As String
    Call CopyMemory(lngEvent, ByVal Mid$(S, 5, 4), 4)
    Call CopyMemory(lngFlags, ByVal Mid$(S, 9, 4), 4)
    Call CopyMemory(lngPing, ByVal Mid$(S, 13, 4), 4)
    strUser = GetSTRING(Mid$(S, 29))
    strMsg = GetSTRING(Mid$(S, 30 + Len(strUser)))
    Call modCHAN.OnBnetChatEvent(lngEvent, lngFlags, lngPing, strUser, strMsg)
End Sub
Private Sub HB1C(ByRef S As String)
    Dim lngResult           As Long
    If (Not Len(S) = 8) Then Exit Sub
    If (Not hBnState = BNS_CHAT) Then Exit Sub 'ignored if ingame
    If (Not modGUI.hGUIA = GUI_CREATE) Then Exit Sub
    Call CopyMemory(lngResult, ByVal Mid$(S, 5, 4), 4)
    On Error GoTo HB1CErr
    Call modGUI.hGUI.OnCreate(lngResult)
HB1CErr:
End Sub
Private Sub HB3A(ByRef S As String)
    Dim lngEvent        As Long
    If (Not hBnState = BNS_ACC_LOGON) Then Exit Sub
    If (Len(S) < 8) Then Exit Sub
    Call CopyMemory(lngEvent, ByVal Mid$(S, 5, 4), 4)
    If (lngEvent = &H0&) Then 'Success
        hBnState = BNS_ENTER_CHAT
        If (Not hBnUDPStamp = 0) Then
            Call SB14
        End If
        Call SB0A
        Call SB0B
        Call SB0C(&H2, hBnHomeChannel)
    ElseIf (lngEvent = &H1&) Then 'Account does not exist
        hBnState = BNS_ACC_CREATE
        sBNET vbRed, "Account Doesn't Exist."
        Call SB3D
    ElseIf (lngEvent = &H2&) Then 'Incorrect passsowrd
        Call OnBNETError(, "Incorrect Password.")
    ElseIf (lngEvent = &H3&) Then 'Account currupt
        Call OnBNETError(, "Account File Currupted.")
    ElseIf (lngEvent = &H6&) Then 'Account closed, custom error
        Call OnBNETError(, strName)
    Else 'Unknown error
        Call OnBNETError(, GetLog(S, "Account Problem " & LngToHex(lngEvent)))
    End If
End Sub
Private Sub HB3D(ByRef S As String)
    Dim lngEvent        As Long
    If (Not hBnState = BNS_ACC_CREATE) Then Exit Sub
    If (Len(S) < 8) Then Exit Sub
    Call CopyMemory(lngEvent, ByVal Mid$(S, 5, 4), 4)
    If (lngEvent = &H0&) Then 'Success
        hBnState = BNS_ACC_LOGON
        Call SB3A
        Exit Sub
    ElseIf (lngEvent = &H1&) Or (lngEvent = &H6&) Then 'Account is invalid lengh
        Call OnBNETError(, "Account Has An Invalid Lengh.")
    ElseIf (lngEvent = &H2&) Then 'Account illegal
        Call OnBNETError(, "Account Is Illegal.")
    ElseIf (lngEvent = &H3&) Then 'Acc has bad words
        Call OnBNETError(, "Account Contains Bad Word's.")
    ElseIf (lngEvent = &H4&) Then 'Acc already exists
        Call OnBNETError(, "Account Already Exist's.")
    Else 'unknown error
        Call OnBNETError(, GetLog(S, "Account Create Problem " & LngToHex(lngEvent)))
    End If
End Sub
Private Sub HB4A(ByRef S As String) 'extrawork.mpq
    If (Len(S) < 6) Then Exit Sub
    Call SB33(&H80000005, GetSTRING(Mid$(S, 5)))
End Sub
Private Sub HB4C(ByRef S As String) 'IX86MindVision.mpq
    If (Len(S) < 6) Then Exit Sub
    Call SB33(&H80000006, GetSTRING(Mid$(S, 5)))
End Sub
Private Sub HB50(ByRef S As String)
    Dim lngPos      As Long: lngPos = 5
    Dim lngNLS      As Long
    Dim udtFT       As FILETIMESTRUT
    Dim strFile     As String
    Dim strFormula  As String
    If (Not hBnState = BNS_0x50) Then Exit Sub
    If (Len(S) < 26) Then Exit Sub
    Call CopyMemory(lngNLS, ByVal Mid$(S, lngPos, 4), 4): lngPos = lngPos + 4
    If (Not lngNLS = &H0&) Then
        Call OnBNETError(, "NLS Problem " & LngToHex(lngNLS))
        Exit Sub
    End If
    Call CopyMemory(hBnServerToken, ByVal Mid$(S, lngPos, 4), 4):   lngPos = lngPos + 4
    Call CopyMemory(hBnUDPToken, ByVal Mid$(S, lngPos, 4), 4):      lngPos = lngPos + 4
    Call CopyMemory(udtFT, ByVal Mid$(S, lngPos, 8), 8):            lngPos = lngPos + 8
    strFile = GetSTRING(Mid$(S, lngPos)):                           lngPos = lngPos + Len(strFile) + 1
    strFormula = GetSTRING(Mid$(S, lngPos)):                        lngPos = lngPos + Len(strFormula) + 1
    hBnState = BNS_GET_CR
    Call modBNLS.SL1A(udtFT, strFile, strFormula)
    Call SU09
    Call SU09
    Call SU09
End Sub
Private Sub HB51(ByRef S As String)
    Dim lngEvent        As Long
    Dim strName         As String
    Dim bIsLOD          As Boolean
    If (Not hBnState = BNS_0x51) Then Exit Sub
    If (Len(S) < 9) Then Exit Sub
    Call CopyMemory(lngEvent, ByVal Mid$(S, 5, 4), 4)
    strName = GetSTRING(Mid$(S, 9))
    bIsLOD = ((lngEvent And &H10) = &H10)
    If bIsLOD Then lngEvent = lngEvent And Not &H10
    If (lngEvent = &H0) Then 'Success!
        hBnState = BNS_ACC_LOGON
        Call SB3A
    ElseIf (lngEvent = &H100&) Then 'Download patch strName
        Call OnBNETError(, "You Need To Install Patch " & strName & ".")
    ElseIf (lngEvent = &H101&) Then 'Invalid Game Version
        Call OnBNETError(, "Invalid Game Version.")
    ElseIf (lngEvent = &H102&) Then 'Downgrade game version with strName
        Call OnBNETError(, "You Need To Downgrade To Patch " & strName & ".")
    ElseIf (lngEvent = &H200&) Then 'Invalid cdkey
        Call OnBNETError(, IIf(bIsLOD, "LOD ", vbNullString) & "CDkey Invalid.")
    ElseIf (lngEvent = &H201&) Then 'Cdkey inuse by strName
        Call OnBNETError(, IIf(bIsLOD, "LOD ", vbNullString) & "CDkey Inuse By: " & strName)
    ElseIf (lngEvent = &H202&) Then 'Cdkey is banned
        Call OnBNETError(, IIf(bIsLOD, "LOD ", vbNullString) & "CDkey Banned.")
    ElseIf (lngEvent = &H203&) Then 'Cdkey for another product
        Call OnBNETError(, IIf(bIsLOD, "LOD ", vbNullString) & "CDkey For Another Product.")
    Else 'Unhandled error
        Call OnBNETError(, GetLog(S, "Logon Problem " & LngToHex(lngEvent)) & ".")
    End If
End Sub




Public Sub SB02()
    Call iClear
    Call iHEADER(&H2)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB09(ByVal lngGameType As Long, _
                ByVal lngSortMethod As Long, _
                Optional ByVal lngListGames As Long = &H19, _
                Optional ByVal strGameName As String = vbNullString, _
                Optional ByVal strGamePass As String = vbNullString, _
                Optional ByVal strGameDesc As String = vbNullString)
    Call iClear
    Call iDWORD(lngGameType)
    Call iDWORD(lngSortMethod)
    Call iDWORD(&H0&)
    Call iDWORD(lngListGames)
    Call iNTSTRING(strGameName)
    Call iNTSTRING(strGamePass)
    Call iNTSTRING(strGameDesc)
    Call iHEADER(&H9)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB0A()
    Call iClear
    Call iNTSTRING(hBnAccount)
    Call iNTSTRING(vbNullString)
    Call iHEADER(&HA)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB0B()
    Call iClear
    Call iDWORD(hBnClient)
    Call iHEADER(&HB)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB0C(ByVal lngFlag As Long, _
                ByVal strChannel As String)
    If (Len(strChannel) > 31) Then strChannel = Left$(strChannel, 31)
    Call iClear
    Call iDWORD(lngFlag)
    Call iNTSTRING(strChannel)
    Call iHEADER(&HC)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB0E(ByVal strChat As String)
    If (Len(strChat) > 500) Then strChat = Left$(strChat, 500)
    Call iClear
    Call iNTSTRING(strChat)
    Call iHEADER(&HE)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB10()
    Call iClear
    Call iHEADER(&H10)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB14()
    Call iClear
    Call iDWORD(hBnUDPStamp)
    Call iHEADER(&H14)
    Call iPacket(hBnHandle)
End Sub
Public Sub SET1C(ByVal intGameType As Integer, _
                 ByVal intPenalty As Integer, _
                 ByVal strName As String, _
                 ByVal strPass As String, _
                 ByVal strStats As String)
    hBnGameState = IIf((Len(strPass) = 0), &H0&, &H1&)
    hBnGameTime = GetTickCountEx()
    hBnGameType = intGameType
    hBnGamePenalty = intPenalty
    hBnGameStatsCode = IIf((intGameType = &H9), &H1&, &H0&)
    hBnGameName = strName
    hBnGamePass = strPass
    hBnGameStats = strStats
End Sub
Public Sub SB1C()
    Dim dblTime         As Long
    dblTime = Int((GetTickCountEx() - hBnGameTime) \ 1000)
    If (dblTime > &H7FFFFFFF) Then
        dblTime = dblTime - 4294967296#
    ElseIf (dblTime < &H80000000) Then
        dblTime = dblTime + 4294967296#
    End If
    Call iClear
    Call iDWORD(hBnGameState)
    Call iDWORD(CLng(dblTime))
    Call iWORD(hBnGameType)
    Call iWORD(hBnGamePenalty)
    Call iDWORD(&H1F&)
    Call iDWORD(hBnGameStatsCode)
    Call iNTSTRING(hBnGameName)
    Call iNTSTRING(hBnGamePass)
    Call iNTSTRING(hBnGameStats)
    Call iHEADER(&H1C)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB22(ByVal strGame As String, ByVal strPass As String)
    Call iClear
    Call iDWORD(hBnClient)
    Call iDWORD(hBnVersionB)
    Call iNTSTRING(strGame)
    Call iNTSTRING(strPass)
    Call iHEADER(&H22)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB25(ByRef strData As String)
    Call iClear
    Call iSTRING(strData)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB3A()
    Dim S           As String: S = Space(14)
    Call CopyMemory(ByVal StrPtr(S), hBnClientToken, 4)
    Call CopyMemory(ByVal StrPtr(S) + 4, hBnServerToken, 4)
    Call CopyMemory(ByVal StrPtr(S) + 8, ByVal BSHA1(LCase(hBnPassword)), 20)
    S = BSHA1(StrConv(S, vbUnicode))
    sBNET vbYellow, "Logging On As " & hBnAccount
    Call iClear
    Call iDWORD(hBnClientToken)
    Call iDWORD(hBnServerToken)
    Call iSTRING(S)
    Call iNTSTRING(hBnAccount)
    Call iHEADER(&H3A)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB3D()
    Dim S       As String * 20
    S = BSHA1(LCase(hBnPassword))
    sBNET vbYellow, "Creating " & hBnAccount
    Call iClear
    Call iSTRING(S)
    Call iNTSTRING(hBnAccount)
    Call iHEADER(&H3D)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB33(ByVal lngID As Long, _
                 ByVal strFile As String)
    Call iClear
    Call iDWORD(lngID)
    Call iDWORD(&H0&)
    Call iNTSTRING(strFile)
    Call iHEADER(&H33)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB50(ByVal lngVByte As Long)
    Dim i           As Long
    Dim strCon      As String
    Dim strConAb    As String
    Dim bBuf(43)    As Long
    Call GetTimeZoneInformation(bBuf(0))
    Call GetLocaleInfoA(GetSystemDefaultLCID(), &H59, bBuf(2), 2)
    Call GetLocaleInfoA(GetSystemDefaultLCID(), &H5A, ByVal VarPtr(bBuf(2)) + 2, 2)
    lngProdLang = htonl(lngProdLang)
    strCon = String$(64, 0)
    strConAb = String$(64, 0)
    strConAb = Left$(strConAb, (GetLocaleInfoA(GetUserDefaultLangID(), &H7, ByVal strConAb, Len(strConAb)) - 1))
    strCon = Left$(strCon, (GetLocaleInfoA(GetUserDefaultLangID(), &H1002, ByVal strCon, Len(strCon)) - 1))
    bBuf(1) = inet_addr&(Form1.hSckBNET.LocalIP)
    sBNET vbYellow, "Sending Local Infomation.."
    Call iClear
    Call iDWORD(&H0&)                       'protocol id
    Call iDWORD(&H49583836)                 'IX86
    Call iDWORD(hClient)                    'Client ID
    Call iDWORD(lngVByte)                   'Clients version byte
    Call iDWORD(bBuf(2))                    'Product Language "SUne"
    Call iDWORD(bBuf(1))                    'Local IP
    Call iDWORD(bBuf(0))                    'TimeZone Bias
    Call iDWORD(GetUserDefaultLCID())       'Locale ID
    Call iDWORD(GetSystemDefaultLCID())     'Language ID
    Call iNTSTRING(strConAb)                'GBR
    Call iNTSTRING(strCon)                  'United Kingdom
    Call iHEADER(&H50)
    Call iPacket(hBnHandle)
End Sub
Private Sub SB51(ByVal lngProduct As Long, _
                 ByVal lngPublic As Long, _
                 ByVal lngPrivate As Long, _
                 ByVal lngKeyLen As Long, _
                 ByVal lngVer As Long, _
                 ByVal lngCSum As Long, _
                 ByVal strInfo As String)
    Dim lngSeed     As Long
    Dim S           As String: S = Space(12)
    Call CopyMemory(ByVal StrPtr(S), hBnClientToken, 4)
    Call CopyMemory(ByVal StrPtr(S) + 4, hBnServerToken, 4)
    Call CopyMemory(ByVal StrPtr(S) + 8, lngProduct, 4)
    Call CopyMemory(ByVal StrPtr(S) + 12, lngPublic, 4)
    Call ZeroMemory(ByVal StrPtr(S) + 16, 4)
    Call CopyMemory(ByVal StrPtr(S) + 20, lngPrivate, 4)
    S = modSHA1.BSHA1(StrConv(S, vbUnicode))
    Call CopyMemory(lngSeed, ByVal S, 4)
    Call modWARDEN.WardenInit(lngSeed, App.Path & "\SEXP_Warden.ini")
    sBNET vbYellow, "Sending CDkey And Version Data.."
    Call iClear
    Call iDWORD(hBnClientToken)
    Call iDWORD(lngVer)
    Call iDWORD(lngCSum)
    Call iDWORD(&H1&)
    Call iDWORD(&H0&)
    Call iDWORD(lngKeyLen)
    Call iDWORD(lngProduct)
    Call iDWORD(lngPublic)
    Call iDWORD(&H0&)
    Call iSTRING(S)
    Call iNTSTRING(strInfo)
    Call iNTSTRING(hBnAccount)
    Call iHEADER(&H51)
    Call iPacket(hBnHandle)
End Sub
Public Sub SB5E(ByRef strData As String)
    If (Len(strData) = 0) Then Exit Sub
    Call iClear
    Call iSTRING(strData)
    Call iHEADER(&H5E)
    Call iPacket(hBnHandle)
End Sub


Private Sub SU09()
    Call iClear
    Call iDWORD(&H9&)
    Call iDWORD(hBnServerToken)
    Call iDWORD(hBnUDPToken)
    Call iUDP(hBnUHandle, inet_addr(Form1.hSckBNET.RemoteHostIP), htons(6112))
End Sub
Public Sub SU03(ByVal lngValue As Long, ByRef lngAddr As Long, ByRef intPort As Integer)
    Call iClear
    Call iDWORD(&H3&)
    Call iDWORD(lngValue)
    Call iUDP(hBnUHandle, lngAddr, intPort)
End Sub
Public Sub sBNET(ByVal lngColor As Long, ByVal strText As String)
    Call modCtrl.sChat(&HC0C000, "[BNET] ")
    Call modCtrl.aChat(lngColor, strText)
End Sub


