Attribute VB_Name = "modImg"
'//Button graphics
Public bmButton(7)      As BITMAPSTRUT
Public bmScrollA(0)     As BITMAPSTRUT 'scroll bar buttons
Public bmScrollB(0)     As BITMAPSTRUT 'scroll bar
Public bmSC             As BITMAPSTRUT
Public bmW2             As BITMAPSTRUT
Public bmD1             As BITMAPSTRUT
Public bmD2             As BITMAPSTRUT
Public bmRating         As BITMAPSTRUT
Public bmMap            As BITMAPSTRUT
'bnet bni files (holds the image blocks)
Public bmIcon           As BITMAPSTRUT
Public bmStar           As BITMAPSTRUT
Public bmW3             As BITMAPSTRUT
Public bmW3Ex           As BITMAPSTRUT

Public biW3()           As BNIICONSTRUT
Public biW3Count        As Integer
Public biW3Ex()         As BNIICONSTRUT
Public biW3ExCount      As Integer
Public biIcon()         As BNIICONSTRUT
Public biIconCount      As Integer
Public biStar()         As BNIICONSTRUT
Public biStarCount      As Integer

Private Type BITMAPINFOHEADER
    biSize              As Long
    biWidth             As Long
    biHeight            As Long
    biPlanes            As Integer
    biBitCount          As Integer
    biCompression       As Long
    biSizeImage         As Long
    biXPelsPerMeter     As Long
    biYPelsPerMeter     As Long
    biClrUsed           As Long
    biClrImportant      As Long
End Type
Private Type BNIHEADER '16 bytes
    Unknown             As Long
    Version             As Long
    TotalIcons          As Long
    IconPos             As Long
End Type
Public Type TGAHEADER
    info                As Byte      'length of image information block
    colortyp            As Byte      'DAC table or BGR format
    tImageType          As Byte      'compressed or uncompressed
    origin              As Integer   'first entry in the DAC table
    colnumber           As Integer   'number of colors in the DAC table
    entrybits           As Byte      'entry size in the DAC table
    tXval               As Integer   'x co-ordinate lower left corner
    tYval               As Integer   'y co-ordinate lower left corner
    tWidth              As Integer   'image width
    tHeight             As Integer   'image height
    tBitCnt             As Byte      'number of bits per pixel
    descriptor          As Byte      'image descriptor
End Type


Public Type BITMAPSTRUT
    Width               As Long
    Height              As Long
    Handle              As Long
End Type
Public Type BNIICONSTRUT
    Flags               As Long
    Width               As Long
    Height              As Long
    Top                 As Long
    Client              As Long
    Handle              As Long
End Type

Public Function LoadImages() As Boolean
    On Error GoTo LoadImagesErr
    Dim i           As Long
    Dim strPath     As String
    strPath = App.Path & "\img\"
    biIconCount = -1
    biStarCount = -1
    biW3Count = -1
    biW3ExCount = -1
    For i = 0 To 7
        Call LoadBMPFile(strPath & "SC" & i & ".bmp", bmButton(i))
    Next i
    For i = 0 To 0
        Call LoadBMPFile(strPath & "SA" & i & ".bmp", bmScrollA(i))
        Call LoadBMPFile(strPath & "SB" & i & ".bmp", bmScrollB(i))
    Next i
    Call LoadBMPFile(strPath & "iSC.bmp", bmSC)
    Call LoadBMPFile(strPath & "iW2.bmp", bmW2)
    Call LoadBMPFile(strPath & "iD1.bmp", bmD1)
    Call LoadBMPFile(strPath & "iD2.bmp", bmD2)
    Call LoadBMPFile(strPath & "iRating.bmp", bmRating)
    Call LoadBMPFile(strPath & "iMap.bmp", bmMap)
    Call LoadBNIFile(strPath & "iW3.bni", bmW3, biW3(), biW3Count)
    Call LoadBNIFile(strPath & "iW3Ex.bni", bmW3Ex, biW3Ex(), biW3ExCount)
    Call LoadBNIFile(strPath & "icons.bni", bmIcon, biIcon(), biIconCount)
    Call LoadBNIFile(strPath & "icons_STAR.bni", bmStar, biStar(), biStarCount)
    LoadImages = True
    Exit Function
LoadImagesErr:
    Call UnloadImages
    LoadImages = False
End Function
Public Sub UnloadImages()
    Dim i           As Long
    biIconCount = -1:   Erase biIcon()
    biStarCount = -1:   Erase biStar()
    biW3Count = -1:     Erase biW3()
    biW3ExCount = -1:   Erase biW3Ex()
    For i = 0 To 7
        Call DeleteObject(bmButton(i).Handle): bmButton(i).Handle = 0
    Next i
    For i = 0 To 0
        Call DeleteObject(bmScrollA(i).Handle): bmScrollA(i).Handle = 0
        Call DeleteObject(bmScrollB(i).Handle): bmScrollB(i).Handle = 0
    Next i
    Call DeleteObject(bmSC.Handle): bmSC.Handle = 0
    Call DeleteObject(bmW2.Handle): bmW2.Handle = 0
    Call DeleteObject(bmD1.Handle): bmD1.Handle = 0
    Call DeleteObject(bmD2.Handle): bmD2.Handle = 0
    Call DeleteObject(bmRating.Handle): bmRating.Handle = 0
    Call DeleteObject(bmMap.Handle): bmMap.Handle = 0
    Call DeleteObject(bmIcon.Handle): bmIcon.Handle = 0
    Call DeleteObject(bmStar.Handle): bmStar.Handle = 0
    Call DeleteObject(bmW3.Handle): bmW3.Handle = 0
    Call DeleteObject(bmW3Ex.Handle): bmW3Ex.Handle = 0
End Sub

Public Sub DrawButton(ByRef B As Project1.clsButton)
    Dim lngDC       As Long
    Dim R           As RECT
    R.Right = B.Width
    R.Bottom = B.Height
    Call B.Cls
    If (B.Style < 0) Or (B.Style > 7) Then Exit Sub
    '//Draw the button image
    R.Left = (bmButton(B.Style).Height \ 5)
    lngDC = CreateCompatibleDC(B.hDC)
    Call SelectObject(lngDC, bmButton(B.Style).Handle)
    Call SetStretchBltMode(B.hDC, &H3&)
    Call StretchBlt(B.hDC, 0, 0, R.Right, R.Bottom, lngDC, 0, (B.State * R.Left), bmButton(B.Style).Width, R.Left, vbSrcPaint)
    Call DeleteDC(lngDC)
    '//Draw the button caption
    lngDC = Len(B.Caption)
    If (lngDC = 0) Then Exit Sub
    If (B.State = 1) Or (B.State = 3) Then 'Button Down, move caption right and down
        R.Top = (B.Height \ R.Left)
        R.Left = (B.Width \ bmButton(B.Style).Width)
        If (R.Left < 1) Then R.Left = 1
        If (R.Top < 1) Then R.Top = 1
        R.Right = R.Right + R.Left
        R.Bottom = R.Bottom + R.Top
    Else
        R.Left = 0
    End If
    Call DrawTextExA(B.hDC, ByVal B.Caption, lngDC, R, DT_SINGLELINE Or DT_VCENTER Or DT_CENTER, ByVal 0&)
End Sub
Public Sub DrawScrollBar(ByRef S As Project1.clsScrollBar)
    Dim lngDC           As Long
    Dim lngTop          As Long
    Dim R               As RECT
    Call SetStretchBltMode(S.hDC, &H3&)
    lngDC = CreateCompatibleDC(S.hDC)
    '//Draw the top/bottom button
    S.Parent.Line (S.Left, S.Top)-(S.Left + S.Width - 1, S.Top + S.Height - 1), RGB(255, 175, 87), B
    Call S.GetUp(R)
    lngTop = IIf(S.Enabled, 0, (bmScrollA(S.Style).Height \ 2))
    Call SelectObject(lngDC, bmScrollA(S.Style).Handle)
    Call StretchBlt(S.hDC, R.Left, R.Top, (R.Right - R.Left), (R.Bottom - R.Top), lngDC, 0, lngTop, bmScrollA(S.Style).Width, (bmScrollA(S.Style).Height \ 4), vbSrcCopy)
    Call S.GetDown(R)
    Call StretchBlt(S.hDC, R.Left, R.Top, (R.Right - R.Left), (R.Bottom - R.Top), lngDC, 0, (lngTop + (bmScrollA(S.Style).Height \ 4)), bmScrollA(S.Style).Width, (bmScrollA(S.Style).Height \ 4), vbSrcCopy)
    '//Draw the scroll bar
    If S.BarVisible Then
        Call S.GetBar(R)
        lngTop = IIf(S.Enabled, 0, (bmScrollB(S.Style).Height \ 2))
        Call SelectObject(lngDC, bmScrollB(S.Style).Handle)
        Call StretchBlt(S.hDC, R.Left, R.Top, (R.Right - R.Left), (R.Bottom - R.Top + 1), lngDC, 0, lngTop, bmScrollB(S.Style).Width, (bmScrollB(S.Style).Height \ 2), vbSrcCopy)
    End If
    Call DeleteDC(lngDC)
End Sub
Public Sub DrawBnChanLv(ByVal lngStart As Long, ByVal lngEnd As Long, ByRef hLv As Project1.clsListView)
    Dim i               As Integer
    Dim i2              As Integer
    Dim lngLeft         As Long
    Dim lngTop          As Long
    Dim lngHeight       As Long
    Dim R               As RECT 'for the text
    Dim hDC             As Long
    Dim lngDC           As Long
    Dim bSelect         As Boolean
    Dim strR            As String * 12
    hDC = hLv.Parent.hDC
    If (lngStart < 0) Then lngStart = 0
    If (lngEnd > hBnetUserCount) Then lngEnd = hBnetUserCount
    Call SetStretchBltMode(hDC, &H3&)
    For i = lngStart To lngEnd
        bSelect = (i = hLv.SelectedIndex)
        lngTop = hLv.Top + hLv.ItemTop(i) + 1
        lngHeight = hLv.ItemHeight(i)
        lngLeft = hLv.Left + 1
        With hBnetUser(i)
            '//Draw the main icon to the back buffer
            If (Not .Icon.Handle = 0) Then
                lngDC = CreateCompatibleDC(hDC)
                Call SelectObject(lngDC, .Icon.Handle)
                Call BitBlt(hDC, lngLeft, lngTop, .Icon.Width, .Icon.Height, lngDC, 0, .Icon.Y, vbSrcCopy)
                Call DeleteDC(lngDC)
                '//Draw the rating for the icon
                If (.Icon.R.Rating > 0) Then
                    strR = Right(Space(.Icon.R.RatingMaxLen) & .Icon.R.Rating, .Icon.R.RatingMaxLen)
                    lngDC = CreateCompatibleDC(hDC)
                    Call SelectObject(lngDC, modImg.bmRating.Handle)
                    For i2 = .Icon.R.RatingMaxLen To 1 Step -1
                        If (Asc(Mid$(strR, i2, 1)) = &H20) Then Exit For
                        Call BitBlt(hDC, lngLeft + ((i2 * 5) + .Icon.R.DrawX), lngTop + .Icon.R.DrawY, 4, 7, lngDC, 4 * 7, (Int(Mid$(strR, i2, 1)) * 7), vbSrcAnd)
                        Call BitBlt(hDC, lngLeft + ((i2 * 5) + .Icon.R.DrawX), lngTop + .Icon.R.DrawY, 4, 7, lngDC, .Icon.R.RatingColor, (Int(Mid$(strR, i2, 1)) * 7), vbSrcPaint)
                    Next i2
                    Call DeleteDC(lngDC)
                End If
                '//Draw dots (Above Rating)
                If (.Icon.D.Rating > 0) Then
                    lngDC = CreateCompatibleDC(hDC)
                    Call SelectObject(lngDC, modImg.bmRating.Handle)
                    For i2 = 1 To .Icon.D.Rating 'draw each dot
                        Call BitBlt(hDC, lngLeft + ((i2 * 5) + .Icon.D.DrawX), lngTop + .Icon.D.DrawY, 4, 3, lngDC, 22, 140 + .Icon.D.RatingColor, vbSrcAnd)
                        Call BitBlt(hDC, lngLeft + ((i2 * 5) + .Icon.D.DrawX), lngTop + .Icon.D.DrawY, 4, 3, lngDC, 18, 140 + .Icon.D.RatingColor, vbSrcPaint)
                    Next i2
                    Call DeleteDC(lngDC)
                End If
                'move right 30 pixels, cos the icon was drawn
                lngLeft = lngLeft + .Icon.Width + 4
            End If
            
            '//Draw selected box
            If bSelect Then
                hLv.Parent.Line (hLv.Left, hLv.Top + hLv.ItemTop(i))-(hLv.Left + hLv.Width - 2, hLv.Top + hLv.ItemTop(i) + hLv.ItemHeight(i)), vbBlue, B
            End If
            
            '//Draw the account name
            R.Left = lngLeft
            R.Top = lngTop
            R.Right = hLv.Width - 16
            R.Bottom = R.Top + lngHeight
            If (R.Right > R.Left) Then
                Call DrawTextExA(hDC, .AccRaw(0), .AccLen, R, DT_SINGLELINE Or DT_VCENTER, ByVal 0&)
            End If
            
            '//Draw the ping icon
            lngLeft = R.Right
            lngTop = lngTop + 3
            If (Not .pIcon.Handle = 0) Then
                lngDC = CreateCompatibleDC(hDC)
                Call SelectObject(lngDC, .pIcon.Handle)
                If ((.Flag And &H10) = &H10) Then 'no need to mask for plug
                    Call BitBlt(hDC, lngLeft, lngTop, .pIcon.Width, .pIcon.Height, lngDC, 0, .pIcon.Y, vbSrcCopy)
                Else
                    Call BitBlt(hDC, lngLeft, lngTop, .pIcon.Width, .pIcon.Height, lngDC, 0, 130, vbSrcAnd)
                    Call BitBlt(hDC, lngLeft, lngTop, .pIcon.Width, .pIcon.Height, lngDC, 0, .pIcon.Y, vbSrcPaint)
                End If
                Call DeleteDC(lngDC)
            End If
            
            '//Draw ping latency
            strR = Left$(.pIcon.R.Rating & Space(.pIcon.R.RatingMaxLen), .pIcon.R.RatingMaxLen)
            lngDC = CreateCompatibleDC(hDC)
            Call SelectObject(lngDC, modImg.bmRating.Handle)
            For i2 = 1 To .pIcon.R.RatingMaxLen
                If Asc(Mid$(strR, i2, 1)) = &H20 Then Exit For
                If IsNumeric(Mid(strR, i2, 1)) = False Then
                    If (Not i2 = 1) Then Exit For
                    '//Draw a -
                    Call BitBlt(hDC, lngLeft + (i2 * 5) + .pIcon.R.DrawX, lngTop + .pIcon.R.DrawY + 3, 4, 1, lngDC, 4 * 7, 0, vbSrcAnd)
                    Call BitBlt(hDC, lngLeft + (i2 * 5) + .pIcon.R.DrawX, lngTop + .pIcon.R.DrawY + 3, 4, 1, lngDC, .pIcon.R.RatingColor, 0, vbSrcPaint)
                Else
                    '//Draw a normal number
                    Call BitBlt(hDC, lngLeft + (i2 * 5) + .pIcon.R.DrawX, lngTop + .pIcon.R.DrawY, 4, 7, lngDC, 4 * 7, (Int(Mid$(strR, i2, 1)) * 7), vbSrcAnd)
                    Call BitBlt(hDC, lngLeft + (i2 * 5) + .pIcon.R.DrawX, lngTop + .pIcon.R.DrawY, 4, 7, lngDC, .pIcon.R.RatingColor, (Int(Mid$(strR, i2, 1)) * 7), vbSrcPaint)
                End If
            Next i2
            Call DeleteDC(lngDC)
        End With
    Next i
End Sub



Public Function FindBNI(ByRef inBNI() As BNIICONSTRUT, _
                        ByRef inBNICount As Integer, _
                        ByVal lngFlags As Long, _
                        ByVal lngClient As Long, _
                        ByRef intOutFlag As Integer) As Integer
    Dim intResult   As Integer
    intResult = -1
    intOutFlag = -1
    For i = 0 To inBNICount
        'Check for flag match (1st priority)
        If (Not lngFlags = 0) And (Not inBNI(i).Flags = 0) Then
            If ((lngFlags And inBNI(i).Flags) = inBNI(i).Flags) Then
                intOutFlag = 0
                FindBNI = i
                Exit Function
            End If
        End If
        'Check for a client match (2nd priority)
        If (lngClient = inBNI(i).Client) Then
            If (intResult = -1) Then
                intOutFlag = 1
                intResult = i
            End If
        End If
    Next i
    FindBNI = intResult
End Function




'##############################################################################
Private Function LoadBackBuffer(ByVal lngWidth As Long, ByVal lngHeight As Long, ByVal lngBits As Long, ByRef bmStrut As BITMAPSTRUT) As Boolean
    bmStrut.Handle = CreateBitmap(lngWidth, lngHeight, 1, lngBits, ByVal 0&)
    If (Not bmStrut.Handle = 0) Then
        bmStrut.Width = lngWidth
        bmStrut.Height = lngHeight
    End If
    LoadBackBuffer = (Not bmStrut.Handle = 0)
End Function
'##############################################################################
Private Function LoadBMPFile(ByVal strPath As String, ByRef bmStrut As BITMAPSTRUT) As Boolean
    If (Len(Dir$(strPath)) = 0) Then Exit Function
    Dim FF          As Integer
    Dim lngLengh    As Long
    Dim bData()     As Byte
    FF = FreeFile()
    Open strPath For Binary As #FF
        lngLengh = LOF(FF)
        If (lngLengh < 27) Then 'file header+core header
            Close #FF
            Exit Function
        End If
        ReDim bData(lngLengh - 1)
        Get #FF, 1, bData()
    Close #FF
    LoadBMPFile = LoadBMP(bData(), lngLengh, 0, bmStrut)
End Function
Private Function LoadBMP(ByRef bData() As Byte, _
                         ByVal lngLengh As Long, _
                         ByVal lngStart As Long, _
                         ByRef bmStrut As BITMAPSTRUT) As Boolean
    Call DeleteObject(bmStrut.Handle)
    Dim lngPos      As Long 'position in the data
    Dim lngDC       As Long
    Dim uInfo       As BITMAPINFOHEADER
    Dim bPal()      As Byte
    lngPos = lngStart
    '//Read the file header
    If ((lngLengh - lngStart) < 27) Then Exit Function 'no headers
    Call CopyMemory(lngDC, bData(lngPos), 2): lngPos = lngPos + 2
    If (Not lngDC = &H4D42&) Then Exit Function 'BM'
    Call CopyMemory(lngDC, bData(lngPos), 4): lngPos = lngPos + 4
    If ((lngLengh - lngStart) < lngDC) Then Exit Function 'file data is missing
    lngPos = lngPos + 8 'skip the rest of the header
    '//Check if its a core of info header
    Call CopyMemory(lngDC, bData(lngPos), 4): lngPos = lngPos + 4
    uInfo.biSize = 40
    If (lngDC = 12) Then 'Core
        Call CopyMemory(uInfo.biWidth, bData(lngPos), 2): lngPos = lngPos + 2
        Call CopyMemory(uInfo.biHeight, bData(lngPos), 2): lngPos = lngPos + 2
        Call CopyMemory(uInfo.biPlanes, bData(lngPos), 2): lngPos = lngPos + 2
        Call CopyMemory(uInfo.biBitCount, bData(lngPos), 2): lngPos = lngPos + 2
        '//TODO:
        '   Core pallets are tripples, not quads
        '   need to sort it out
    ElseIf (lngDC = 40) Then 'Info
        Call CopyMemory(uInfo, bData(lngPos - 4), 40)
        lngPos = lngPos + 36 'skip the header
    Else
        Exit Function
    End If
    '//Get the palette size
    Select Case uInfo.biBitCount
        Case 1:             lngDC = 8
        Case 4:             lngDC = 64
        Case 8:             lngDC = 1024
        Case 16, 24, 32:    lngDC = 0
        Case Else:  Exit Function
    End Select
    ReDim bPal(39 + lngDC)
    If (lngDC > 0) Then
        Call CopyMemory(bPal(40), bData(lngPos), lngDC)
        lngPos = lngPos + lngDC
    End If
    '//Copy the bitmap header to the start of the palette
    Call CopyMemory(bPal(0), uInfo, 40)
    '//Create the bitmap
    lngDC = GetDC(0)
    bmStrut.Handle = CreateDIBitmap(lngDC, uInfo, &H4, bData(lngPos), bPal(0), &H0)
    Call DeleteDC(lngDC)
    If (Not bmStrut.Handle = 0) Then
        bmStrut.Width = uInfo.biWidth
        bmStrut.Height = uInfo.biHeight
        LoadBMP = True
    End If
End Function
'##############################################################################
Private Function LoadBNIFile(ByVal strPath As String, ByRef bmStrut As BITMAPSTRUT, ByRef bniStrut() As BNIICONSTRUT, ByRef bniStrutCount As Integer) As Boolean
    If (Len(Dir$(strPath)) = 0) Then Exit Function
    Dim FF          As Integer
    Dim lngLengh    As Long
    Dim bData()     As Byte
    FF = FreeFile()
    Open strPath For Binary As #FF
        lngLengh = LOF(FF)
        If (lngLengh < 17) Then
            Close #FF
            Exit Function
        End If
        ReDim bData(lngLengh - 1)
        Get #FF, 1, bData()
    Close #FF
    LoadBNIFile = LoadBNI(bData(), lngLengh, 0, bmStrut, bniStrut(), bniStrutCount)
End Function
Private Function LoadBNI(ByRef bData() As Byte, _
                         ByVal lngLengh As Long, _
                         ByVal lngStart As Long, _
                         ByRef bmStrut As BITMAPSTRUT, _
                         ByRef bniStrut() As BNIICONSTRUT, _
                         ByRef bniStrutCount As Integer) As Boolean
    Dim uHeader     As BNIHEADER
    Dim uBNI()      As BNIICONSTRUT
    Dim uBNICount   As Integer
    Dim i           As Integer
    Dim lngTop      As Long
    Dim lngPos      As Long 'position in the data
    lngPos = lngStart
    '//Read and check the header
    If ((lngLengh - lngPos) < 16) Then Exit Function
    Call CopyMemory(uHeader, bData(lngPos), 16&): lngPos = lngPos + 16
    If (Not uHeader.Unknown = &H10) Then Exit Function 'Unknown ID
    If (Not uHeader.Version = &H1) And (Not uHeader.Version = &H5) Then Exit Function 'Unknown BNI Version
    If (uHeader.TotalIcons < 1) Then Exit Function 'no icons in the file?
    If (uHeader.TotalIcons > 1000) Then Exit Function 'mass icons?
    If (uHeader.IconPos >= lngLengh) Then Exit Function 'no icon/tga data?
    '//Parse the icon clients/flags
    uBNICount = (uHeader.TotalIcons - 1)
    ReDim uBNI(uBNICount)
    lngTop = 0
    For i = 0 To uBNICount
        If ((lngLengh - (lngPos + 12)) < 0) Then Exit Function
        Call CopyMemory(uBNI(i).Flags, bData(lngPos), 4): lngPos = lngPos + 4
        Call CopyMemory(uBNI(i).Width, bData(lngPos), 4): lngPos = lngPos + 4
        Call CopyMemory(uBNI(i).Height, bData(lngPos), 4): lngPos = lngPos + 4
        If (uBNI(i).Flags = 0) Then  'client based
            uBNI(i).Client = 0
            While (uBNI(i).Client = 0)
                If (lngLengh - (lngPos + 8)) < 0 Then Exit Function
                Call CopyMemory(uBNI(i).Client, bData(lngPos), 4): lngPos = lngPos + 4
            Wend
        End If
        lngPos = lngPos + 4 'blank dword after client
        uBNI(i).Top = lngTop
        lngTop = lngTop + uBNI(i).Height
    Next i
    If (Not lngPos = uHeader.IconPos) Then Exit Function
    If (uHeader.Version = &H1) Then 'TGA
        If (LoadTGA(bData(), lngLengh, uHeader.IconPos, bmStrut) = False) Then Exit Function
    ElseIf (uHeader.Version = &H5) Then 'BMP
        If (LoadBMP(bData(), lngLengh, uHeader.IconPos, bmStrut) = False) Then Exit Function
    End If
    bniStrutCount = uBNICount
    ReDim bniStrut(uBNICount)
    For i = 0 To uBNICount
        bniStrut(i) = uBNI(i)
        bniStrut(i).Handle = bmStrut.Handle
    Next i
    LoadBNI = True
End Function
'##############################################################################
Private Function LoadTGAFile(ByVal strPath As String, ByRef bmStrut As BITMAPSTRUT) As Boolean
    If (Len(Dir$(strPath)) = 0) Then Exit Function
    Dim FF          As Integer
    Dim lngLengh    As Long
    Dim bData()     As Byte
    FF = FreeFile
    Open strPath For Binary As #FF
        lngLengh = LOF(FF)
        If (lngLengh < 19) Then
            Close #FF
            Exit Function
        End If
        ReDim bData(lngLengh - 1)
        Get #FF, 1, bData()
    Close #FF
    LoadTGAFile = LoadTGA(bData(), lngLengh, 0, bmStrut)
End Function
Private Function LoadTGA(ByRef bData() As Byte, _
                         ByVal lngLengh As Long, _
                         ByVal lngStart As Long, _
                         ByRef bmStrut As BITMAPSTRUT) As Boolean
    Call DeleteObject(bmStrut.Handle)
    Dim i           As Long
    Dim lngPos      As Long
    Dim uHeader     As TGAHEADER
    Dim uInfo       As BITMAPINFOHEADER
    Dim lngSize     As Long
    Dim bRaw()      As Byte 'the TGA data after decompression
    Dim bHead(43)   As Byte
    lngPos = lngStart
    If ((lngPos + 19) > lngLengh) Then Exit Function 'no header?
    'copy the header
    uHeader.info = bData(lngPos): lngPos = lngPos + 1
    uHeader.colortyp = bData(lngPos): lngPos = lngPos + 1
    uHeader.tImageType = bData(lngPos): lngPos = lngPos + 1
    Call CopyMemory(uHeader.origin, bData(lngPos), 2): lngPos = lngPos + 2
    Call CopyMemory(uHeader.colnumber, bData(lngPos), 2): lngPos = lngPos + 2
    uHeader.entrybits = bData(lngPos): lngPos = lngPos + 1
    Call CopyMemory(uHeader.tXval, bData(lngPos), 2): lngPos = lngPos + 2
    Call CopyMemory(uHeader.tYval, bData(lngPos), 2): lngPos = lngPos + 2
    Call CopyMemory(uHeader.tWidth, bData(lngPos), 2): lngPos = lngPos + 2
    Call CopyMemory(uHeader.tHeight, bData(lngPos), 2): lngPos = lngPos + 2
    uHeader.tBitCnt = bData(lngPos): lngPos = lngPos + 1
    uHeader.descriptor = bData(lngPos): lngPos = lngPos + 1
    '//Get the true width/height
    uHeader.tWidth = (uHeader.tWidth - uHeader.tXval)
    uHeader.tHeight = (uHeader.tHeight - uHeader.tYval)
    '//Make sure the bit count is valid
    Select Case uHeader.tBitCnt
        Case 16, 24
        Case Else: Exit Function
    End Select
    
    lngSize = (uHeader.tWidth * uHeader.tHeight * (uHeader.tBitCnt / 8))
    ReDim bRaw(lngSize)
    If ((uHeader.tImageType = 9) Or (uHeader.tImageType = 10)) Then 'compressed
        Call DecompTGA(bData(), lngPos, lngLengh, uHeader.tBitCnt, bRaw(), lngSize)
    Else
        If ((lngPos + lngSize) > lngLengh) Then Exit Function
        Call CopyMemory(bRaw(0), bData(lngPos), lngSize)
    End If
    '//Create the bitmap
    uInfo.biSize = 40
    uInfo.biWidth = uHeader.tWidth
    uInfo.biHeight = IIf(((uHeader.tBitCnt = 24) And ((uHeader.descriptor And &H20) = &H20)), -uHeader.tHeight, uHeader.tHeight)
    uInfo.biPlanes = 1
    uInfo.biBitCount = uHeader.tBitCnt
    Call CopyMemory(bHead(0), uInfo, 40)
    lngSize = GetDC(0)
    bmStrut.Handle = CreateDIBitmap(lngSize, uInfo, &H4, bRaw(0), bHead(0), &H0)
    Call DeleteDC(lngSize)
    If (Not bmStrut.Handle = 0) Then
        bmStrut.Width = uHeader.tWidth
        bmStrut.Height = uHeader.tHeight
    End If
    LoadTGA = (Not bmStrut.Handle = 0)
End Function
Private Sub DecompTGA(ByRef bData() As Byte, ByVal lngPos As Long, ByVal lngLengh As Long, ByVal lngBits As Long, ByRef bOut() As Byte, ByVal lngSize As Long)
    Dim i               As Long
    Dim A               As Long
    Dim B               As Long
    Dim N               As Long
    Dim Z               As Long
    Dim lngOut          As Long 'pos in the out data
    lngBits = lngBits / 8
    i = lngPos
    Do While lngOut < lngSize
        If (i > lngLengh) Then Exit Do
        Z = 0
        If (bData(i) > 127) Then
            N = (bData(i) - 127)
            For B = 0 To N - 1
                CopyMemory bOut(lngOut), bData(i + 1), lngBits
                lngOut = lngOut + lngBits
            Next B
            i = (lngBits + 1) + i
            N = Z + (N * lngBits) + 1
        Else
            N = bData(i) + 1
            A = N * lngBits
            CopyMemory bOut(lngOut), bData(i + 1), A
            Z = Z + A
            lngOut = lngOut + Z
            i = (N * lngBits + 1) + i
            N = Z + N
        End If
    Loop
End Sub
